/*
 * nanoGallery v3.1.1
 * Plugin for GetSimple CMS by Christophe Brisbois
 * http://www.brisbois.fr
 * 
 * External components:
 *  - jQuery (http://www.jquery.com)
 *  - fancybox (http://www.fancybox.net)
 */

 
function nanoGALLERY() {

	var g_user= "";
	var g_settingsObj=null;
	var g_containerFolder=null;
	var g_containerBreadcrumb=null;
	var g_path2timthumb="";
	var g_tW=230;
	var g_tH=154;
	var g_options=null;
	var g_picasaThumbSize=64;
	var g_picasaThumbAvailableSizes=new Array(32, 48, 64, 72, 94, 104, 110, 128, 144, 150, 160, 200, 220, 288, 320, 400, 512, 576, 640, 720, 800, 912, 1024, 1152, 1280, 1440, 1600);
	var g_flickrThumbSize='s';
	var g_flickrThumbAvailableSizes=new Array(75,100,150,240,320,500,640,800,1024);		//see http://www.flickr.com/services/api/misc.urls.html
	var g_flickrThumbAvailableSizesStr=new Array('s','t','q','m','n','-','z','c','b');
	var g_displayCaption=false;
	var g_blackList=null;
	var g_itemInfo=new Array();
	var g_flickrApiKey="2f0e634b471fdb47446abcb9c5afebdc";
	var g_instance=0;
	
	this.Initiate=function(elementID, params, instance) {
		"use strict";
	
		g_options=params;
		g_instance=instance;
	
		if( g_options.thumbnailHeight !== undefined ) { g_tH=params.thumbnailHeight; }
		if( g_options.thumbnailWidth !== undefined ) { g_tW=params.thumbnailWidth; }
		if( g_options.displayCaption !== undefined ) { g_displayCaption=params.displayCaption; }
		if( g_options.blackList !== undefined ) { g_blackList=g_options.blackList.toUpperCase().split('|'); }
		if( g_options.theme !== undefined && g_options.theme != 'default') {
			jQuery('#'+elementID).addClass('nanogallery_theme_'+g_options.theme); }
		else {
			jQuery('#'+elementID).addClass('nanogallery_theme_default'); }
	
		if( g_options.photoset !== undefined ) {
			if( g_options.photoset.length > 0) { g_options.displayBreadcrumb=false; }
		}
		else { g_options.photoset=''; }
		if( g_options.album !== undefined ) {
			if( g_options.album.length > 0 ) { g_options.displayBreadcrumb=false; }
		}
		else { g_options.album=''; }
	
		if( g_options.displayBreadcrumb == true ) { g_containerBreadcrumb =jQuery('<div class="nanoGalleryBreadcrumb" id="nanoGalleryBreadcrumb'+g_instance+'"></div>').appendTo('#'+elementID); }
		g_containerFolder =jQuery('<div class="nanoGalleryContainer" id="nanoGalleryContainer'+g_instance+'"></div>').appendTo('#'+elementID);
		g_path2timthumb = ""; //timthumbFolder;


		var si=0;
		if( g_tW > g_tH ) { si=g_tW; }
		else { si=g_tH; }

		g_user = params.userID;
		switch(params.kind) {
			case "getsimple":
				var url=params.pluginURL+'/nanogallery_getitems.php';
				alert(url);
				//$.getJSON(url+'/nanogallery_getitems.php', {limit: 1}, function(data) {
				//$.getJSON(url+'/nanogallery_getitems.php', function(data) {
				jQuery.ajaxSetup({ cache: false });
				jQuery.support.cors = true;
				jQuery.getJSON(url, function(data) {
					alert("ok");
					// data is now an array with all the images
					$.each(data, function(i) {
						alert(data[i]);
						// do something with each image
						// data[i] will have the image path
					});
				});
				alert("done");
				break;
				
			case "flickr":
				for( i=0; i<g_flickrThumbAvailableSizes.length; i++) {
					g_flickrThumbSize=g_flickrThumbAvailableSizesStr[i];
					if( si < g_flickrThumbAvailableSizes[i] ) {
						break;
					}
				}
				FlickrGetItems(g_options.photoset,'Home');
				break;
			default:
				for(var i=0; i<g_picasaThumbAvailableSizes.length; i++) {
					g_picasaThumbSize=g_picasaThumbAvailableSizes[i];
					if( si < g_picasaThumbAvailableSizes[i] ) {
						break;
					}
				}
				PicasaGetItems(g_options.album,'Home');
				break;
		}
	};
	

	// ##### FLICKR STORAGE #####
	function FlickrGetItems( itemID, albumLabel ) {
		var obj=null;

		// breadcrumb
		if( g_options.displayBreadcrumb == true ) {
			if( albumLabel != "" ) {
				if( jQuery('#nanoGalleryBreadcrumb'+g_instance).children().length > 0 ) {
					jQuery('<div class="separator">&nbsp;>&nbsp;</div>').appendTo('#nanoGalleryBreadcrumb'+g_instance);
				}
				var newDiv =jQuery('<div class="folder">'+albumLabel+'</div>').appendTo('#nanoGalleryBreadcrumb'+g_instance);
				jQuery(newDiv).data("path",itemID);
				newDiv.click(function() {
					var folder=jQuery(this).data("path");
					jQuery(this).nextAll().remove();
					FlickrGetItems(folder,'',g_instance);
				});;
			}
		}
		
		jQuery('#nanoGalleryContainer'+g_instance).children().remove();

		// RETRIEVE PHOTOSETS
		if( itemID == '' ) {
			var url = "http://api.flickr.com/services/rest/?&method=flickr.photosets.getList&api_key=" + g_flickrApiKey + "&user_id="+g_user+"&format=json&jsoncallback=?";
			kind='album';

			// get the content and display it
			jQuery.ajaxSetup({ cache: false });
			jQuery.support.cors = true;
			jQuery.getJSON(url, function(data) {
				settingsObj = data;
				g_itemInfo=new Array();

				jQuery.each(data.photosets.photoset, function(i,item){
					//Get the title 
					itemTitle = item.title._content;
					itemID=item.id;
					//Get the description
					itemDescription='';
					if (item.description._content != undefined)
						itemDescription=item.description._content;
					itemThumbURL = "http://farm" + item.farm + ".staticflickr.com/" + item.server + "/" + item.primary + "_" + item.secret + "_"+g_flickrThumbSize+".jpg";
					imgUrl=''
					itemKind=kind;

					if( g_blackList !== null ) {
						//blackList : ignore album cointaining one of the specified keyword in the title
						var found=false;
						var s=itemTitle.toUpperCase();
						for( var j=0; j<g_blackList.length; j++) {
							if( s.indexOf(g_blackList[j]) !== -1 ) { return true; }
						}
					}

					var newDiv =jQuery('<div class="container"></div>').appendTo('#nanoGalleryContainer'+g_instance);
					jQuery(newDiv).append('<div class="imgcont"><img class="image" src="'+itemThumbURL+'"></div>');

					if( g_displayCaption == true ) {jQuery(newDiv).append('<div class="labelFolder">'+itemTitle+'</div>'); }
					g_itemInfo[i]=new Array(itemTitle, itemThumbURL, itemID, itemDescription,itemKind);
					
					jQuery(newDiv).data("index",i);
					newDiv.click(function() {
						var n=jQuery(this).data("index");
						FlickrGetItems(g_itemInfo[i][2],g_itemInfo[i][0],g_instance);
					});
				});
				SetContainerSize();

			});		
			
		}
		// RETRIEVE PHOTOS
		else {
			var url = "http://api.flickr.com/services/rest/?&method=flickr.photosets.getPhotos&api_key=" + g_flickrApiKey + "&photoset_id="+itemID+"&extras=views,url_s,url_o,url_m&format=json&jsoncallback=?";
			kind='photo';

			// get the content and display it
			jQuery.ajaxSetup({ cache: false });
			jQuery.support.cors = true;
			jQuery.getJSON(url, function(data) {
				settingsObj = data;
				g_itemInfo=new Array();

				jQuery.each(data.photoset.photo, function(i,item){
					//Get the title 
					itemTitle = item.title._content;
					itemID=item.id;
					//Get the description
					itemDescription='';
					itemThumbURL = "http://farm" + item.farm + ".staticflickr.com/" + item.server + "/" + item.id +"_" + item.secret + "_"+g_flickrThumbSize+".jpg";
					imgUrl = "http://farm" + item.farm + ".staticflickr.com/" + item.server + "/" + item.id + "_" + item.secret + "_o.jpg";


					itemKind=kind;

					var newDiv =jQuery('<div class="container"></div>').appendTo('#nanoGalleryContainer'+g_instance);
					jQuery(newDiv).append('<div class="imgcont"><img class="image" src="'+itemThumbURL+'"></div>');

					var s=itemTitle;
					if( g_displayCaption == true ) {
						if( s ===undefined || s.length == 0 ) { s=i+1; }
						jQuery(newDiv).append('<div class="labelImage">'+s+'</div>');
					}
					g_itemInfo[i]=new Array(itemTitle, itemThumbURL, imgUrl, itemDescription, itemKind);

					jQuery(newDiv).data("index",i);
					newDiv.click(function() { OpenFancyBox(this); });
				});
				SetContainerSize();
			});		
		}
	};

	
	// ##### PICASA STORAGE #####
	function PicasaGetItems( itemID, albumLabel ) {
		jQuery('#nanoGalleryContainer'+g_instance).children().remove();
		if( itemID == '' ) {
			var url = 'http://picasaweb.google.com/data/feed/api/user/'+g_user+'?alt=json&kind=album&thumbsize='+g_picasaThumbSize;
			kind='album';
		}
		else {
			var url = 'http://picasaweb.google.com/data/feed/api/user/'+g_user+'/albumid/'+itemID+'?alt=json&kind=photo&thumbsize='+g_picasaThumbSize+'&imgmax=d';
			kind='photo';
		}

		// breadcrumb
		if( g_options.displayBreadcrumb == true ) {
			if( albumLabel != "" ) {
				if( jQuery('#nanoGalleryBreadcrumb'+g_instance).children().length > 0 ) {
					jQuery('<div class="separator">&nbsp;>&nbsp;</div>').appendTo('#nanoGalleryBreadcrumb'+g_instance);
				}
				var newDiv =jQuery('<div class="folder">'+albumLabel+'</div>').appendTo('#nanoGalleryBreadcrumb'+g_instance);
				jQuery(newDiv).data("path",itemID);
				newDiv.click(function() {
					var folder=jQuery(this).data("path");
					jQuery(this).nextAll().remove();
					PicasaGetItems(folder,'');
				});;
			}
		}
		
		
		// get the content and display it
		jQuery.ajaxSetup({ cache: false });
		jQuery.support.cors = true;
		url = url + "&callback=?";
		jQuery.getJSON(url, function(data) {
			g_settingsObj = data;
			g_itemInfo=new Array();
			
			jQuery.each(data.feed.entry, function(i,data){
				//Get the title 
				itemTitle = data.media$group.media$title.$t;
				//Get the URL of the thumbnail
				itemThumbURL = data.media$group.media$thumbnail[0].url;
				//Get the ID 
				itemID = data.id.$t;
				itemID = itemID.split('/')[9].split('?')[0];
				//Get the description
				itemDescription = data.media$group.media$description.$t;
				imgUrl=data.media$group.media$content[0].url
				itemKind=kind;

				if( g_blackList !== null && kind == 'album' ) {
					//blackList : ignore album cointaining one of the specified keyword in the title
					var found=false;
					var s=itemTitle.toUpperCase();
					for( var j=0; j<g_blackList.length; j++) {
						if( s.indexOf(g_blackList[j]) !== -1 ) { return true; }
					}
				}
				var newDiv =jQuery('<div class="container"></div>').appendTo('#nanoGalleryContainer'+g_instance);
				jQuery(newDiv).append('<div class="imgcont"><img class="image" src="'+itemThumbURL+'"></div>');
				if( kind == 'album' ) {
					if( g_displayCaption == true ) { jQuery(newDiv).append('<div class="labelFolder">'+itemTitle+'</div>'); }
					g_itemInfo[i]=new Array(itemTitle, itemThumbURL, itemID, itemDescription,itemKind);
				}
				else {
					var s=itemDescription;
					if( g_displayCaption == true ) {
						if( s.length == 0 ) { s=i+1; }
						jQuery(newDiv).append('<div class="labelImage">'+s+'</div>');
					}
					g_itemInfo[i]=new Array(itemTitle, itemThumbURL, imgUrl, itemDescription, itemKind);
				}

				jQuery(newDiv).data("index",i);
				newDiv.click(function() {
					var n=jQuery(this).data("index");
					if( g_itemInfo[n][4] == 'album' ) {
						PicasaGetItems(g_itemInfo[i][2],g_itemInfo[i][0],g_instance);
					}
					else {
						OpenFancyBox(this);
					}
				});
			});
			SetContainerSize();

		})
		.error( function(XMLHttpRequest, textStatus, errorThrown) {
			alert("Error with Picasa: " + textStatus);
		});
	};
	
	function OpenFancyBox(element) {
		var n=jQuery(element).data("index");
		var lstImages=new Array();
		lstImages[0]=g_itemInfo[n][2];
		for( var j=n+1; j<g_itemInfo.length; j++) {
			lstImages[lstImages.length]=g_itemInfo[j][2];
		}
		for( var j=0; j<n; j++) {
			lstImages[lstImages.length]=g_itemInfo[j][2];
		}
		jQuery.fancybox.open(lstImages,{'autoPlay':false, 'nextEffect':'fade', 'prevEffect':'fade','scrolling':'no',
			helpers		: {	buttons	: { 'position' : 'bottom'} }
		});
	};
	
	function SetContainerSize() {
		jQuery('#nanoGalleryContainer'+g_instance).find('.imgcont').css('width',g_tW);
		jQuery('#nanoGalleryContainer'+g_instance).find('.imgcont').css('height',g_tH);
		jQuery('#nanoGalleryContainer'+g_instance).find('img').css('maxWidth',g_tW);
		jQuery('#nanoGalleryContainer'+g_instance).find('img').css('maxHeight',g_tH);
	};
	

}